<?php
/* $Id: RegIpAddressUtil.php,v 1.5 2004/02/27 07:26:01 yoshi_s Exp $ */
?>
<?php
/**
 * ̾  RegIpAddressUtil
 *   IPAddressϢΥ桼ƥƥ饹
 *   new ɬפʤstaticȤƴؿѲǽ
 */
class RegIpAddressUtil
{
	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_sequence_num_ipv4
	 *   ɥåȷ 10 ɽ IP ɥ쥹Ϣ³ֹ֤
	 * @param  start_cidr		string	IPɥ쥹(xxx.xxx.xxx.xxx/xx)	(i)
	 * @return int[]  IPɥ쥹Ϣ³ֹɽ(顼null)
	 *                [0]:start_sequence_number[1]:end_sequence_number[2]:prefix_length
	 */
	function get_sequence_num_ipv4($start_cidr)
	{
		if ($start_cidr == null)
			return FALSE;
		//ɥåȷɥ쥹,4Ĥο
		if (ereg("([0-9]{1,3})\.([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})\/([0-9]{1,2})", $start_cidr, $regs) == FALSE)
		{
			return FALSE;		// 顼
		}

		$byte_1st = (int)$regs[1];
		$byte_2nd = (int)$regs[2];
		$byte_3rd = (int)$regs[3];
		$byte_4th = (int)$regs[4];
		$prefix_length = (int)$regs[5];

		//줿ͤĤοϢ³ֹѴơץեĹȤȤ֤
		$start_sequence_number =
			$byte_1st * pow(256, 3) + $byte_2nd * pow(256, 2) + $byte_3rd * 256 + $byte_4th;
		$end_sequence_number = $start_sequence_number + pow(2, 32 - $prefix_length) - 1;

		return array($start_sequence_number, $end_sequence_number, $prefix_length);
	}

	/**
	 * ؿ̾chk_ipaddress_mask
	 *   ɥ쥹ȥޥåϥɥ쥹˥ޥ򤫤ƥۥ 0 ˤʤ뤳
	 * @param  ip_block		string	IPAddress(xxx.xxx.xxx.xxx/xx)	(i)
	 * @return 0顼1
	 * @desc   ɥ쥹ΥեޥåȥåϹԤʤŬ礷ʤϥ顼Ȥ 0 ֤
	 */
	function chk_ipaddress_mask($ip_block)
	{
		// ,λ,maskʬ::startsequence[0]endsequence[1]mask[2]
		$result = RegIpAddressUtil::get_sequence_num_ipv4($ip_block);
		if ($result === FALSE)
		{
			return 0;		// 顼
		}

		$mask = pow(2, 32 - $result[2]) - 1;	// ޥ
		// ϥɥ쥹˥ޥ򤫤ƥۥ 0 ˤʤ뤳
		$masked_addr = gmp_intval(gmp_and((string)$result[0], (string)$mask));

		if($masked_addr)
		{
			return 0;		// 顼
		}
		return 1;
	}

	/**
	 * ؿ̾chk_ip_overlap
	 *   2ĤIPɥ쥹֥åνʣطȽꤹ롣
	 * @param  ip_block_1	string	IPAddress(xxx.xxx.xxx.xxx/xx)	(i)
	 * @param  ip_block_2	string	IPAddress(xxx.xxx.xxx.xxx/xx)	(i)
	 * @return -1顼
	 *          0ʣʤ
	 *          1(Ʊɥ쥹ϰ)
	 *          2ʣ
	 *                *------*      or       *------*		ip_block_1
	 *                    *------*      *------*			ip_block_2
	 *          3$ip_block_1פϡ$ip_block_2פϰ
	 *                    *------*							ip_block_1
	 *                *--------------*						ip_block_2
	 *          4$ip_block_2פϡ$ip_block_1פϰ
	 *                *--------------*						ip_block_1
	 *                    *------*							ip_block_2
	 * @desc   ɥ쥹ΥեޥåȥåϹԤʤŬ礷ʤ-1֤
	 */
	function chk_ip_overlap($ip_block_1, $ip_block_2)
	{
		$result_1 = RegIpAddressUtil::get_sequence_num_ipv4($ip_block_1);
		$result_2 = RegIpAddressUtil::get_sequence_num_ipv4($ip_block_2);
		if ($result_1 === FALSE || $result_2 === FALSE)
		{
			return -1;
		}

		if ($result_1[0] == $result_2[0] && $result_1[1] == $result_2[1] && $result_1[2] == $result_2[2])
		{
			return 1;		// 
		}
		else if (($result_1[0] < $result_2[0]) && (($result_2[0] < $result_1[1]) && ($result_1[1] < $result_2[1])))
		{
			return 2;		// ʣ
		}
		else if (($result_2[0] < $result_1[0]) && (($result_1[0] < $result_2[1]) && ($result_2[1] < $result_1[1])))
		{
			return 2;		// ʣ
		}
		else if (($result_2[0] <= $result_1[0]) && ($result_1[1] <= $result_2[1]))
		{
			return 3;		// ip_block_1  ip_block_2 ϰ
		}
		else if (($result_1[0] <= $result_2[0]) && ($result_2[1] <= $result_1[1]))
		{
			return 4;		// ip_block_2  ip_block_1 ϰ
		}

		return 0;		// ʣʤ
	}

	/**
	 * ؿ̾chk_ip_array_overlap
	 *   IPɥ쥹֥åνʣطȽꤹ롣
	 * @param  ip_blocks	string[]	IPAddress(xxx.xxx.xxx.xxx/xx)	(i)
	 * @return  FALSEʣʤ
	 *          TRUE ʣ
	 * @desc   ɥ쥹ΥեޥåȥåϹԤʤ
	 */
	function chk_ip_array_overlap($ip_blocks)
	{
		$ip_count = count($ip_blocks);
		if ($ip_count < 2)
		{
			return FALSE;
		}

		for ($n = 0; $n < $ip_count; $n++)
		{
			for ($nsearch = $n + 1; $nsearch < $ip_count; $nsearch++)
			{
				if (RegIpAddressUtil::chk_ip_overlap($ip_blocks[$n], $ip_blocks[$nsearch]) !== 0)
				{
					return TRUE;		// ʣ
				}
			}
		}
		return FALSE;		// ʣʤ
	}

	/**
	 * ؿ̾chk_ipaddress_private
	 *   IPɥ쥹ץ饤١ȥɥ쥹ɤȽꤹ롣
	 * @param  ip_block		string	IPAddress				(i)
	 *                              (xxx.xxx.xxx.xxx/xx or xxx.xxx.xxx.xxx)
	 * @return int -1顼0ץ饤١ȥɥ쥹ʳ1ץ饤١ȥɥ쥹
	 * @desc   ɥ쥹ΥեޥåȥåϹԤʤŬ礷ʤ-1֤
	 */
	function chk_ipaddress_private($ip_block)
	{
		$value	= explode("/", $ip_block);
		if (!(count($value) == 1 || count($value) == 2))
		{
			return -1;
		}
		$addr	= explode(".", $value[0]);
		if (count($addr) != 4)
		{
			return -1;
		}

		// A Class 10.0.0.0  10.255.255.255
		if ($addr[0] == 10)
			return 1;

		// B Class 172.16.0.0  172.31.255.255
		if ($addr[0] == 172 && ($addr[1] >= 16 && $addr[1] <= 31))
			return 1;

		// C Class 192.168.0.0  192.168.255.255
		if ($addr[0] == 192 && $addr[1] == 168)
			return 1;

		return 0;
	}

	/**
	 * ؿ̾get_hostnum_from_ipaddress
	 *   CIDRɽΥɥ쥹бۥȿ
	 * @param  ip_block		string	IPAddress				(i)
	 *                              (xxx.xxx.xxx.xxx/xx)
	 * @return 0顼ret_data[0]ۥȿ, ret_data[1]ץե
	 */
	function get_hostnum_from_ipaddress($ip_block)
	{
		//ɥåȷɥ쥹,4Ĥο
		if (ereg("([0-9]{1,3})\.([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})\/([0-9]{1,2})", $ip_block, $regs) == FALSE)
		{
			return 0;		// 顼
		}
		$ret_data[0] = RegIpAddressUtil::get_hostnum_from_prefix((int)$regs[5]);
		$ret_data[1] = (int)$regs[5];
		return $ret_data;
	}

	/**
	 * ؿ̾get_hostnum_from_prefix
	 *   ץեåĹбۥȿ
	 * @param  prefix_length	integer		ץեåĹ		(i)
	 * @return int	ۥȿ
	 */
	function get_hostnum_from_prefix($prefix_length)
	{
		return pow(2, 32 - $prefix_length);
	}
}
?>