<?php
/* $Id: RegIpv6AddressUtil.php,v 1.20 2004/02/16 14:23:33 yoshi_s Exp $ */
?>
<?php
/**
 * ̾  RegIpv6AddressUtil
 *   IPv6AddressϢΥ桼ƥƥ饹
 *   new ɬפʤstaticȤƴؿѲǽ
 */
class RegIpv6AddressUtil{

    //***********************************************************************
    // public methods
    //***********************************************************************
    
    /**
     * ؿ̾ : uncompress_ipaddress
     *    : IPv6ɥ쥹άʤɽѴ
     *      : 2001::1 -> 2001:0000:0000:0000:0000:0000:0000:0001
     * @access  public
     * @param   string  $ip         ipv6ɥ쥹
     * @param   string  [$stype]    ̤֤ݤΥեɤη
     *                              pad"0"᤹[default], reduce"0"ʤ, ignoreʤˤ⤷ʤ
     * @return  string  ɽipv6ɥ쥹
     * @desc    ipv6ɥ쥹δܷå̵Ȥʤä false ֤
     * @see     compress_ipaddress()
     */
    function uncompress_ipaddress($ip, $style="pad"){
        // ܷå
        if(!RegIpv6AddressUtil::_chk_ipaddress_base($ip)){
            return false;
        }
        $uncomp_ip = "";
        // άɽξ
        if(strstr($ip, "::")){
            list($fields1, $fields2) = explode("::", $ip);
            $f1 = strcmp($fields1, '') ? explode(":", $fields1) : array("0");
            $f2 = strcmp($fields2, '') ? explode(":", $fields2) : array("0");
            $omits = array_fill(0, 8 - (count($f1) + count($f2)), 0);
            $uncomp_ip = join(":", array_merge($f1, $omits, $f2));
        // άɽǤʤ
        }else{
            $uncomp_ip = $ip;
        }
        // եɤηʥ˽
        return RegIpv6AddressUtil::_field_style_ipaddress($uncomp_ip, $style);
    }
    
    /**
     * ؿ̾ : compress_ipaddress
     *    : IPv6ɥ쥹άɽѴ
     *      : 2001:0000:0000:0000:0000:0000:0000:0001 -> 2001::1
     * @access  public
     * @param   string  $ip         ipv6ɥ쥹
     * @param   string  [$stype]    ̤֤ݤΥեɤη
     *                              reduce"0"ʤ[default], pad"0"᤹, ignoreʤˤ⤷ʤ
     * @return  string  άɽipv6ɥ쥹
     * @desc    ipv6ɥ쥹δܷå̵Ȥʤä false ֤
     * @see     uncompress_ipaddress()
     */
    function compress_ipaddress($ip, $style="reduce"){
        // ܷå
        if(!RegIpv6AddressUtil::_chk_ipaddress_base($ip)){
            return false;
        }
        // ɽѴ"0"ǤϢ³Ƥõ
        $fields = explode(":", RegIpv6AddressUtil::uncompress_ipaddress($ip));
        $zero     = array("start" => 0, "count" => 0);
        $max_zero = array("start" => 0, "count" => 0, "end" => 0);
        $idx = 0;
        foreach ($fields as $f){
            if(preg_match("/^0+$/", $f)){
                if(!$zero["count"]){ $zero["start"] = $idx; }
                $zero["count"]++;
            }elseif($zero["count"] > 0){
                if($max_zero["count"] < $zero["count"]){
                    $max_zero = $zero;
                    $max_zero["end"] = $idx - 1;
                }
                $zero = array("start" => 0, "count" => 0);
            }
            $idx++;
        }
        if($max_zero["count"] < $zero["count"]){
            $max_zero = $zero;
            $max_zero["end"] = 7;
        }
        $comp_ip = "";
        // ̤Ǥ
        if($max_zero["count"] > 1){
            // ̳ϾȽλʸ(%)
            $comp_fields = array();
            $idx = 0;
            foreach ($fields as $f){
                array_push($comp_fields, 
                    ($max_zero["start"] == $idx || $max_zero["end"] == $idx) ? '%' : $f);
                $idx++;
            }
            if($max_zero["end"] == 7){
                $comp_fields[7] = '%';
            }
            // ʸ˶ޤ줿ʬ򰵽()ˤ
            $comp_ip = preg_replace("/%.*%/", '', join(":", $comp_fields));
            if($max_zero["start"] == 0){
                $comp_ip = ":".$comp_ip;
            }
            if($max_zero["end"] == 7){
                $comp_ip .= ":";
            }
        // ̤Ǥʤ
        }else{
            $comp_ip = $ip;
        }
        // եɤηʥ˽
        return RegIpv6AddressUtil::_field_style_ipaddress($comp_ip, $style);
    }
    
    /**
     * ؿ̾ : chk_ipaddress
     *    : IPv6ɥ쥹ǧ
     * @access  public
     * @param   string  $ip     ipv6ɥ쥹
     * @return  bool    ͭtrue, ̵false
     * @desc    uncompress_ipaddress()Ѥå
     * @see     uncompress_ipaddress()
     */
    function chk_ipaddress($ip){
        $reg = join(":", array_fill(0, 8, "[0-9a-f]{4}"));
        return preg_match("/^$reg$/", RegIpv6AddressUtil::uncompress_ipaddress($ip));
    }
    
    /**
     * ؿ̾ : chk_ipblock
     *    : IPv6֥åǧ
     *          ϥɥ쥹˥ޥ򤫤ƥۥ 0 ˤʤ뤳
     * @access  public
     * @param   string  $cidr   IPv6֥å (ex. 2001:1:1:1::/64)
     * @return  bool    ͭtrue, ̵false
     * @see     chk_ipaddress()
     */
    function chk_ipblock($cidr){
        if(!preg_match("/^([0-9a-f:]+)\/([0-9]+)$/", $cidr, $matches)){
            return false;
        }elseif(!RegIpv6AddressUtil::chk_ipaddress($matches[1])){
            return false;
        }elseif($matches[2] < 1 || 128 < $matches[2]){
            return false;
        }
        $ipaddr_resource = RegIpv6AddressUtil::ipv6_to_gmp($matches[1]);
        $mask_resource = gmp_sub(gmp_pow(2, 128 - $matches[2]), gmp_init("1"));
        return gmp_cmp(gmp_and($ipaddr_resource, $mask_resource), gmp_init("0")) ? false : true;
    }
    
    /**
     * ؿ̾ : get_sequence_num
     *    : :˶ڤIPv6ɥ쥹Ϣ³ֹ꥽gmp˾
     * @access  public
     * @param   string  $cidr           IPv6֥å (ex. 2001:1:1:1::/64)
     * @param   string  [$return_type]  ̤֤ݤηη
     *                                  (string|str)string [default]
     *                                  (resource|res|gmp): gmp resource
     * @return  array   IPɥ쥹Ϣ³ֹ
     *                  [0]:start_seq(str|res)[1]:end_seq(str|res)[2]:prefix_length
     * @see     uncompress_ipaddress()
     */
    function get_sequence_num($cidr, $return_type="str"){
        // å
        if(!RegIpv6AddressUtil::chk_ipblock($cidr)){
            return false;
        }
        // Ϣ³ֹ
        list($ip, $prefix) = explode("/", $cidr);
        $start_cidr_gmp = RegIpv6AddressUtil::ipv6_to_gmp($ip);
        $end_cidr_gmp = gmp_add($start_cidr_gmp, 
            gmp_sub(gmp_pow(2, 128 - $prefix), gmp_init("1")));
        // ̷ν
        $start_seq = "";
        $end_seq = "";
        switch ($return_type){
        case "gmp":
        case "res":
        case "resource":
            $start_seq = $start_cidr_gmp;
            $end_seq = $end_cidr_gmp;
            break;
        case "str":
        case "string":
        default:
            $start_seq = RegIpv6AddressUtil::gmp_to_seq($start_cidr_gmp);
            $end_seq = RegIpv6AddressUtil::gmp_to_seq($end_cidr_gmp);
        }
        return array($start_seq, $end_seq, $prefix);
    }
    
    /**
     * ؿ̾ : chk_ipblock_overlap
     *    : 2ĤIPv6ɥ쥹֥åνʣطȽꤹ
     * @access  public
     * @param   string  $cidr1  IPv6֥å (ex. 2001:1:1:1::/64)
     * @param   string  $cidr2  IPv6֥å (ex. 2001:1:1:1::/64)
     * @return  integer Ƚ
     *              -1: 顼
     *              0:  ʣʤ
     *              1:  (Ʊɥ쥹ϰ)
     *              2:  ʣ
     *                  *------*      or       *------*       cidr1
     *                      *------*      *------*            cidr2
     *              3:  cidr1  cidr2 ϰ
     *                      *------*                          cidr1
     *                  *--------------*                      cidr2
     *              4:  cidr2  cidr1 ϰ
     *                  *--------------*                      cidr1
     *                      *------*                          cidr2
     * @see     get_sequence_num()
     */
    function chk_ipblock_overlap($cidr1, $cidr2){
        // Ϣ³ֹ꥽
        $c1 = RegIpv6AddressUtil::get_sequence_num($cidr1, "res");
        $c2 = RegIpv6AddressUtil::get_sequence_num($cidr2, "res");
        if ($c1 === false || $c2 === false){
            return -1;
        }
        list($c1_start, $c1_end, $c1_prefix) = $c1;
        list($c2_start, $c2_end, $c2_prefix) = $c2;
        // cidr1  cidr2 ϴ
        if(!gmp_cmp($c1_start, $c2_start) && !gmp_cmp($c1_end, $c2_end) && $c1_prefix == $c2_prefix){
            return 1;
        // cidr2  cidr1 ϰ  cidr2 <<= cidr1
        }elseif(gmp_cmp($c1_start, $c2_start) <= 0 && gmp_cmp($c2_end, $c1_end) <= 0){
            return 4;
        // cidr1  cidr2 ϰ  cidr1 <<= cidr2
        }elseif(gmp_cmp($c2_start, $c1_start) <= 0 && gmp_cmp($c1_end, $c2_end) <= 0){
            return 3;
        // cidr1  cidr2 Ͻʣ
        }elseif((gmp_cmp($c1_start, $c2_start) <= 0 && gmp_cmp($c2_start, $c1_end) <= 0)
            ||  (gmp_cmp($c1_start, $c2_end)   <= 0 && gmp_cmp($c2_end, $c1_end)   <= 0)
            ||  (gmp_cmp($c2_start, $c1_start) <= 0 && gmp_cmp($c1_start, $c2_end) <= 0)
            ||  (gmp_cmp($c2_start, $c1_end)   <= 0 && gmp_cmp($c1_end, $c2_end)   <= 0)
        ){
            return 2;
        }
        // cidr1  cidr2 Ͻʣʤ
        return 0;
    }
    
    /**
     * ؿ̾ : chk_ipblock_array_overlap
     *    : IPv6ɥ쥹֥åνʣطȽꤹ
     * @access  public
     * @param   array   $cidrs  IPv6֥åꥹ
     * @return  bool    Ƚ̡ʽʣꡧtrue, ʣ̵false
     * @see     chk_ipblock_overlap()
     */
    function chk_ipblock_array_overlap($cidrs){
        $cnt = count($cidrs);
        if($cnt < 2){
            return false;
        }
        for($i = 0; $i < $cnt; $i++){
            for($j = $i + 1; $j < $cnt; $j++){
                if(RegIpv6AddressUtil::chk_ipblock_overlap($cidrs[$i], $cidrs[$j])){
                    // ʣ
                    return true;
                }
            }
        }
        // ʣ̵
        return false;
    }
    
    /**
     * ؿ̾ : get_hostnum_from_prefix
     *    : ץեåĹбۥȿ
     * @access  public
     * @param   integer $prefix ץեåĹ
     * @return  string  ۥȿʸ *integerȷ夢դ줹Τstring֤*
     */
    function get_hostnum_from_prefix($prefix){
        return gmp_strval(gmp_pow(2, 128 - $prefix));
    }
    
    /**
     * ؿ̾ : chk_user_illegal_block
     *    : DBϿʤIPv6֥åȽꤹ
     *          RegCnfCommon.php Ƥ $conf_user_illegal_block ѿ
     *          ȤȽ
     * @access  public
     * @param   string  $cidr   IPv6֥å    (ex. 2001:1:1:1::/64)
     * @return  integer Ƚ
     *                  -1顼
     *                  0DBϿʤIPv6֥åʳ
     *                  1DBϿʤIPv6֥å
     */
    function chk_user_illegal_block($cidr){
        // å
        if(!RegIpv6AddressUtil::chk_ipblock($cidr)){
            return -1;
        }
        // configեͤȾȹ
        include("config/RegCnfCommon.php");
        if(!is_array($cnf_user_illegal_block)){
            return 0;
        }
        foreach ($cnf_user_illegal_block as $conf_cidr){
            // ʣå
            if(RegIpv6AddressUtil::chk_ipblock_overlap($cidr, $conf_cidr)){
                return 1;
            }
        }
        return 0;
    }
    
    /**
     * ؿ̾ : chk_not_user_global_block
     *    : 桼ѤǤʤХ륢ɥ쥹֥åȽꤹ
     *          RegCnfCommon.php Ƥ $conf_not_user_global_block ѿ
     *          ȤȽ
     * @access  public
     * @param   string  $cidr   IPv6֥å    (ex. 2001:1:1:1::/64)
     * @return  integer Ƚ
     *                  -1顼
     *                  0桼ѤǤʤХ륢ɥ쥹֥åʳ
     *                  1桼ѤǤʤХ륢ɥ쥹֥å
     */
    function chk_not_user_global_block($cidr){
        // å
        if(!RegIpv6AddressUtil::chk_ipblock($cidr)){
            return -1;
        }
        // configեͤȾȹ
        include("config/RegCnfCommon.php");
        if(!is_array($cnf_not_user_global_block)){
            return 0;
        }
        foreach ($cnf_not_user_global_block as $conf_cidr){
            // ʣå
            if(RegIpv6AddressUtil::chk_ipblock_overlap($cidr, $conf_cidr)){
                return 1;
            }
        }
        return 0;
    }
    
    /**
     * ؿ̾ : seq_to_gmp
     *    : Ϣ³ֹgmp resourceͤѴ
     * @access  public
     * @param   srting      $seq    Ϣ³ֹʸ
     * @return  resource    gmp resource
     * @see     gmp_to_seq()
     */
    function seq_to_gmp($seq){
        return gmp_init("0x".$seq);
    }
    
    /**
     * ؿ̾ : seq_to_ipv6
     *    : Ϣ³ֹipv6ɥ쥹Ѵ
     * @access  public
     * @param   srting      $seq    Ϣ³ֹʸ
     * @return  string  IPv6ɥ쥹ʸ
     * @see     ipv6_to_seq()
     */
    function seq_to_ipv6($seq){
        preg_match_all("/[0-9a-f]{4}/", $seq, $matches, PREG_PATTERN_ORDER);
        return join(":", $matches[0]);
    }
    
    /**
     * ؿ̾ : gmp_to_seq
     *    : gmp resourceͤϢ³ֹѴ
     * @access  public
     * @param   resource    $gmp    gmp resource
     * @return  string  Ϣ³ֹʸ
     * @see     seq_to_gmp()
     */
    function gmp_to_seq($gmp){
        return sprintf("%032s", gmp_strval($gmp, 16));
    }
    
    /**
     * ؿ̾ : gmp_to_ipv6
     *    : gmp resourceͤipv6ɥ쥹Ѵ
     * @access  public
     * @param   resource    $gmp    gmp resource
     * @return  string  IPv6ɥ쥹ʸ
     * @see     ipv6_to_gmp()
     */
    function gmp_to_ipv6($gmp){
        return RegIpv6AddressUtil::seq_to_ipv6(RegIpv6AddressUtil::gmp_to_seq($gmp));
    }
    
    /**
     * ؿ̾ : ipv6_to_seq
     *    : ipv6ɥ쥹Ϣ³ֹѴ
     * @access  public
     * @param   srting      $ip     IPv6ɥ쥹ʸ
     * @return  string  Ϣ³ֹʸ
     * @see     seq_to_ipv6()
     */
    function ipv6_to_seq($ip){
        return str_replace(":", "", RegIpv6AddressUtil::uncompress_ipaddress($ip));
    }
    
    /**
     * ؿ̾ : ipv6_to_gmp
     *    : ipv6ɥ쥹gmp resourceͤѴ
     * @access  public
     * @param   srting      $ip     IPv6ɥ쥹ʸ
     * @return  resource    gmp resource
     * @see     gmp_to_ipv6()
     */
    function ipv6_to_gmp($ip){
        return RegIpv6AddressUtil::seq_to_gmp(RegIpv6AddressUtil::ipv6_to_seq($ip));
    }
    
    /**
     * ؿ̾ : conv_ipaddress_format
     *    : ipv6ɥ쥹ǤդηѴ
     * @access  public
     * @param   (resource|string)   $ip     IPv6ɥ쥹
     *                                      (gmp resource ޤϡipv6ޤϡ16ʿֹ)
     * @param   string      $return_type    Ѵ
     *                                      (gmp|res|resource): gmp resource
     *                                      (seq|sequence): 16ʿֹ
     *                                      (ipv6): ipv6
     * @param   string      [$input_type]   ($ip)η
     *                                      (gmp|res|resource): gmp resource
     *                                      (seq|sequence): 16ʿֹ
     *                                      (ipv6): ipv6
     *                                      ꤬ʤϼưȽ
     * @return  (resource|string)   ǤդηѴ
     */
    function conv_ipaddress_format($ip, $return_type, $input_type=""){
        // ưȽ
        if(!strcmp($input_type, "")){
            if(is_resource($ip)){
                $input_type = "gmp";
            }elseif(preg_match("/^[0-9a-f]{32}$/", $input_type)){
                $input_type = "seq";
            }elseif(RegIpv6AddressUtil::chk_ipaddress($ip)){
                $input_type = "ipv6";
            }else{
                return $ip;
            }
        }
        // ͤηϢ³ֹ
        $seq = "";
        switch ($input_type){
        case "gmp":
        case "res":
        case "resource":
            $seq = RegIpv6AddressUtil::gmp_to_seq($ip);
            break;
        case "ipv6":
            $seq = RegIpv6AddressUtil::ipv6_to_seq($ip);
            break;
        case "seq":
        case "sequecne":
            $seq = $ip;
            break;
        default:
            return $ip;
        }
        // ǤդηѴ
        $rtn = "";
        switch ($return_type){
        case "gmp":
        case "res":
        case "resource":
            $rtn = RegIpv6AddressUtil::seq_to_gmp($seq);
            break;
        case "ipv6":
            $rtn = RegIpv6AddressUtil::seq_to_ipv6($seq);
            break;
        case "seq":
        case "sequecne":
            $rtn = $seq;
            break;
        default:
            return $ip;
        }
        return $rtn;
    }
    
    /**
     * ؿ̾ : divide_ipblock
     *    : ֹ桢λֹ椫CIDRɽIPɥ쥹֥å׻
     * @access  public
     * @param   resource    $start  ֹ (gmp resource ޤϡipv6ޤϡ16ʿֹ)
     * @param   resource    $end    λֹ (gmp resource ޤϡipv6ޤϡ16ʿֹ)
     * @return  array       CIDRɽIPɥ쥹֥å
     */
    function divide_ipblock($start, $end){
        // gmp resourceͤˤ
        $start_gmp = RegIpv6AddressUtil::conv_ipaddress_format($start, "res");
        $end_gmp = RegIpv6AddressUtil::conv_ipaddress_format($end, "res");
        // ʬ
        $cidr_blocks = array();
        while (gmp_cmp($end_gmp, $start_gmp) >= 0){
            ////////// ֹ //////////
            // ۥȿ
            $hosts_gmp = gmp_add(gmp_sub($end_gmp, $start_gmp), gmp_init("1"));
            // Ȥʤۥȿ
            $idx = gmp_scan1($start_gmp, 0);
            if(gmp_cmp($start_gmp, gmp_init("0")) == 0){
                continue;
            }
            $can_hosts_gmp = gmp_pow(gmp_init("2"), $idx);
            // ۥȿ >= ۥȿǤäʬ
            if(gmp_cmp($hosts_gmp, $can_hosts_gmp) >= 0){
                $prefix = 128 - $idx;
                array_push($cidr_blocks, RegIpv6AddressUtil::gmp_to_ipv6($start_gmp)."/". $prefix);
                $start_gmp = gmp_add($start_gmp, $can_hosts_gmp);
            }
            ////////// λֹ //////////
            // ۥȿ
            $hosts_gmp = gmp_add(gmp_sub($end_gmp, $start_gmp), gmp_init("1"));
            // Ȥʤۥȿ
            $idx = gmp_scan0($end_gmp, 0);
            if(gmp_cmp(gmp_init("128"), gmp_init("$idx")) < 0){
                continue;
            }
            $can_hosts_gmp = gmp_pow(gmp_init("2"), $idx);
            // ۥȿ >= ۥȿǤäʬ
            if(gmp_cmp($hosts_gmp, $can_hosts_gmp) >= 0){
                $prefix = 128 - $idx;
                $block_start_gmp = gmp_add(gmp_sub($end_gmp, $can_hosts_gmp), gmp_init("1"));
                array_push($cidr_blocks, RegIpv6AddressUtil::gmp_to_ipv6($block_start_gmp)."/". $prefix);
                $end_gmp = gmp_sub($block_start_gmp, gmp_init("1"));
            }
        }
        sort($cidr_blocks);
        return $cidr_blocks;
    }
    
    /**
     * ؿ̾ : reduce_ipblock
     *    : cidr1֥åcidr2֥å
     * @access  public
     * @param   string  $cidr1   ȤΥ֥åipv6
     * @param   string  $cidr2   ֥åipv6
     * @return  array       CIDRɽIPɥ쥹֥å
     */
    function reduce_ipblock($cidr1, $cidr2){
        // Ϣ³ֹ꥽
        $c1 = RegIpv6AddressUtil::get_sequence_num($cidr1, "res");
        $c2 = RegIpv6AddressUtil::get_sequence_num($cidr2, "res");
        if ($c1 === false || $c2 === false){
            return -1;
        }
        list($c1_start, $c1_end, $c1_prefix) = $c1;
        list($c2_start, $c2_end, $c2_prefix) = $c2;
        $cidr_blocks = array();
        // cidr1: *-----------*
        // cidr2:     *---*
        if(gmp_cmp($c1_start, $c2_start) < 0 && gmp_cmp($c1_end, $c2_end) > 0){
            // Ⱦ
            $from = $c1_start;
            $to = gmp_sub($c2_start, gmp_init("1"));
            $cidr_blocks = RegIpv6AddressUtil::divide_ipblock($from, $to);
            // Ⱦ
            $from = gmp_add($c2_end, gmp_init("1"));
            $to = $c1_end;
            $cidr_blocks = array_merge($cidrs, RegIpv6AddressUtil::divide_ipblock($from, $to));
        // cidr1: *-----------*
        // cidr2: *---*
        }elseif(gmp_cmp($c1_start, $c2_start) == 0 && gmp_cmp($c1_end, $c2_end) > 0){
            $from = gmp_add($c2_end, gmp_init("1"));
            $to = $c1_end;
            $cidr_blocks = RegIpv6AddressUtil::divide_ipblock($from, $to);
        // cidr1: *-----------*
        // cidr2:         *---*
        }elseif(gmp_cmp($c1_start, $c2_start) < 0 && gmp_cmp($c1_end, $c2_end) == 0){
            $from = $c1_start;
            $to = gmp_sub($c2_start, gmp_init("1"));
            $cidr_blocks = RegIpv6AddressUtil::divide_ipblock($from, $to);
        }
        sort($cidr_blocks);
        return $cidr_blocks;
    }
    
    //***********************************************************************
    // private methods
    //***********************************************************************
    
    /**
     * ؿ̾ : _chk_ipaddress_base
     *    : ipv6ɥ쥹δܷǧ
     * @access  private
     * @param   string  $ip     ipv6ɥ쥹
     * @return  bool    ͭtrue, ̵false
     */
    function _chk_ipaddress_base($ip){

        $tmp = array();
        // ʸ
        if(!preg_match("/^[:0-9a-f]+$/", $ip)
        // ":"İʾ³Ƥʤ
        || strstr($ip, ":::")
        // "::"ʣ¸ߤƤʤ
        || preg_match_all("/::/", $ip, $tmp) > 1
        // ":"Ƕڤäܤİʾʤ
        || count(explode(":", $ip)) > 8
        // Ƭޤ":"ʸǤʤ
        || preg_match("/(^:[^:])|([^:]:$)/", $ip)){
            return false;
        }
        return true;
    }
    
    /**
     * ؿ̾ : _field_style_ipaddress
     *    : IPv6ɥ쥹ΥեɤηѴ
     * @access  private
     * @param   string  $ip         ipv6ɥ쥹
     * @param   string  $stype      ̤֤ݤΥեɤη
     *                              pad"0"᤹, reduce"0"ʤ, ignoreʤˤ⤷ʤ
     * @return  string  ѴIPv6ɥ쥹
     * @see     _pad_zero_ipaddress(), _reduce_zero_ipaddress()
     */
    function _field_style_ipaddress($ip, $style){
        switch ($style){
        case "pad":
            $ip = RegIpv6AddressUtil::_pad_zero_ipaddress($ip);
            break;
        case "reduce":
            $ip = RegIpv6AddressUtil::_reduce_zero_ipaddress($ip);
            break;
        }
        return $ip;
    }
    
    /**
     * ؿ̾ : _pad_zero_ipaddress
     *    : ipv6ɥ쥹Υեɤ"0"᤹
     *      : 2001:0:0:0:0:0:0:1 -> 2001:0000:0000:0000:0000:0000:0000:0001
     * @access  private
     * @param   string  $ip     ipv6ɥ쥹
     * @return  string  եɤ"0"ᤷipv6ɥ쥹
     * @see     _reduce_zero_ipaddress()
     */
    function _pad_zero_ipaddress($ip){
        $tmp_array = array();
        foreach (explode(":", $ip) as $f){
            array_push($tmp_array, strcmp($f, '') ? sprintf("%04s", $f) : '');
        }
        return join(":", $tmp_array);
    }
    
    /**
     * ؿ̾ : _reduce_zero_ipaddress
     *    : ipv6ɥ쥹ΥեɤƬ"0"ʤ
     *      : 2001:0000:0000:0000:0000:0000:0000:0001 -> 2001:0:0:0:0:0:0:1
     * @access  private
     * @param   string  $ip     ipv6ɥ쥹
     * @return  string  եɤƬ"0"ʤipv6ɥ쥹
     * @see     _pad_zero_ipaddress()
     */
    function _reduce_zero_ipaddress($ip){
        $tmp_array = array();
        foreach (explode(":", $ip) as $f){
            if(preg_match("/^0+$/", $f)){
                $f = 0;
            }elseif(preg_match("/^0+([1-9a-f][0-9a-f]*)$/", $f, $matches)){
                $f = $matches[1];
            }
            array_push($tmp_array,  $f);
        }
        return join(":", $tmp_array);
    }
}
?>
