<?php
/**
 * $Id: RegV6pcLog.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
 */
?>
<?php
/**
 * ̾  RegV6pcLog
 *   ɸϥ饹syslogd Ѥ facility,priority ̤ΥϤԤ
 *   new ɬܤǤϤʤ󥹥ȥ饯facilityꤹˡ˾ޤ
 */
class RegV6pcLog
{
	//-----------------------------------------------------------------------
	// fields
	//-----------------------------------------------------------------------
	/**
	 * syslog facilityꤷʤ LOG_USER
	 */
	var $m_facility = LOG_USER;

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegV6pcLog
	 *   RegV6pcLog饹󥹥ȥ饯m_facility ꤷƹۤ롣
	 * @param  facility			int		syslog facility		(i)
	 */
	function RegV6pcLog($facility = LOG_USER)
	{
		$this->m_facility = $facility;
	}

	/**
	 * ؿ̾emerg
	 *   Log Message EMERG "system is unusable"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function emerg($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_EMERG, "emerg", $message, $filename, $line);
	}

	/**
	 * ؿ̾alert
	 *   Log Message ALERT "action must be taken immesiately"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function alert($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_ALERT, "alert", $message, $filename, $line);
	}

	/**
	 * ؿ̾crit
	 *   Log Message CRIT "critical conditions"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function crit($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_CRIT, "crit", $message, $filename, $line);
	}

	/**
	 * ؿ̾err
	 *   Log Message ERR "error conditions"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function err($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_ERR, "err", $message, $filename, $line);
	}

	/**
	 * ؿ̾warning
	 *   Log Message WARNING "warning conditions"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function warning($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_WARNING, "warning", $message, $filename, $line);
	}

	/**
	 * ؿ̾notice
	 *   Log Message NOTICE "normal, but significant, condition"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function notice($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_NOTICE, "notice", $message, $filename, $line);
	}

	/**
	 * ؿ̾info
	 *   Log Message INFO "informational message"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function info($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_INFO, "info", $message, $filename, $line);
	}

	/**
	 * ؿ̾debug
	 *   Log Message DEBUG "debug-level message"
	 * @param  $message			string	MESSAGE			(i)
	 * @param  $filename		string	__FILE__		(i)
	 * @param  $line			string	__LINE__		(i)
	 * @return int		syslogؿ
	 */
	function debug($message, $filename="", $line="")
	{
		return RegV6pcLog::_syslog(LOG_DEBUG, "debug", $message, $filename, $line);
	}

	//-----------------------------------------------------------------------
	// private methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾_syslog
	 *   Log Message output(facility=user)
	 *         ex)Nov  1 18:51:18 net43-db01 V6PC[89228]: [user.emerg]/v6pc-dev/v6pc/common/test.php(39):message
	 * @param  $priority		string	syslog priority		(i)
	 * @param  $level			string	syslog level		(i)
	 * @param  $mes				string	log message			(i)
	 * @param  $filename		string	__FILE__			(i)
	 * @param  $line			string	__LINE__			(i)
	 * @return syslog
	 */
	function _syslog($priority, $level, $mes, $filename, $line)
	{
		if (isset($this->m_facility) == FALSE)
		{
			$this->m_facility = LOG_USER;
		}

		// facility å
		$str_facility;
		switch ($this->m_facility)
		{
		case LOG_AUTH:
			$str_facility = "auth";
			break;
		case LOG_AUTHPRIV:
			$str_facility = "authpriv";
			break;
		case LOG_CRON:
			$str_facility = "cron";
			break;
		case LOG_DAEMON:
			$str_facility = "daemon";
			break;
		case LOG_KERN:
			$str_facility = "kern";
			break;
		case LOG_LOCAL0:
			$str_facility = "local0";
			break;
		case LOG_LOCAL1:
			$str_facility = "local1";
			break;
		case LOG_LOCAL2:
			$str_facility = "local2";
			break;
		case LOG_LOCAL3:
			$str_facility = "local3";
			break;
		case LOG_LOCAL4:
			$str_facility = "local4";
			break;
		case LOG_LOCAL5:
			$str_facility = "local5";
			break;
		case LOG_LOCAL6:
			$str_facility = "local6";
			break;
		case LOG_LOCAL7:
			$str_facility = "local7";
			break;
		case LOG_LPR:
			$str_facility = "lpr";
			break;
		case LOG_MAIL:
			$str_facility = "mail";
			break;
		case LOG_NEWS:
			$str_facility = "news";
			break;
		case LOG_SYSLOG:
			$str_facility = "syslog";
			break;
		case LOG_USER:
			$str_facility = "user";
			break;
		case LOG_UUCP:
			$str_facility = "uucp";
			break;
		default:
			$str_facility = "user";
			$this->m_facility = LOG_USER;
			break;
		}

		// "V6PC"ʸդץIDդǤ˽
		openlog("V6PC", LOG_PID | LOG_NDELAY, $this->m_facility);
		if ($line)
			$filename = "$filename($line)";
		if ($filename)
			$mes = "$filename:$mes";
		$lv = "[$str_facility.{$level}]";

		// 130ʸĽ
		for ($i = 0; $i < strlen($mes); $i+=130)
		{
			$ret = syslog($priority, $lv.mb_substr($mes, $i, 130));
		}
		closelog();
		return $ret;
	}
}
?>
