<?php
//$Id: result.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $

class DB_RESULT_INFO {
  var $is_error;
  var $db_error_info;
  var $db_result_info;
  
  function DB_RESULT_INFO($is_error,$db_error_info,$db_result_info){
    $this->is_error = $is_error;
    $this->db_error_info = $db_error_info;
    $this->db_result_info = $db_result_info;        
  }
}

class DB_ERROR_INFO {
  var $file;
  var $line;
  var $error_code;
  var $error_message;

  function DB_ERROR_INFO ($file,$line,$error_code,$error_message ){
    $this->file = $file;
    $this->line = $line;
    $this->error_code = $error_code;
    $this->error_message = $error_message;
    }
}

/*
 * ؿ: DoCheckDBErrorGet
 * : ˤpg_exec֤ͤΥ顼åȸ̤0ʾǤ뤳Ȥå
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DoCheckDBErrorGet($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤
  if(!$result)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  //̤0ʤ饨顼֤
  if(pg_numrows($result) == 0)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,"DB-700","֥Ȥμ˼Ԥޤ"), null);
  //̤֤
  return new DB_RESULT_INFO(false, null, true);
}

/*
 * ؿ: DoCheckDBErrorSelect
 * : ˤpg_exec֤ͤΥ顼åԤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DoCheckDBErrorSelect($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  //̤֤
  return new DB_RESULT_INFO(false, null, true);
}

/*
 * ؿ: DoCheckDBErrorInsertOne
 * : ꡼ˤpg_exec֤ͤΥ顼åȡԿ0ʾǤ뤳Ȥå
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DoCheckDBErrorInsertOne($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  $cmdtuples = pg_cmdtuples ($result);
  //̤0ʤ饨顼֤  
  if($cmdtuples == 0)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,"DB-701","֥Ȥ˼Ԥޤ"),null);
  //̤֤  
  return new DB_RESULT_INFO(false, null, true);  
}

/*
 * ؿ: DoCheckDBErrorInsertOneorZero
 * : ꡼ˤpg_exec֤ͤΥ顼åԤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return integer  Կ
*/
function DoCheckDBErrorInsertOneorZero($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  $cmdtuples = pg_cmdtuples ($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $cmdtuples);  
}

/*
 * ؿ: DoCheckDBErrorUpdateOne
 * : ꡼ˤpg_exec֤ͤΥ顼åȺԿ0ʾǤ뤳Ȥå
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DoCheckDBErrorUpdateOne($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  $cmdtuples = pg_cmdtuples ($result);
  //̤0ʤ饨顼֤  
  if($cmdtuples == 0)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,"DB-702","֥Ȥι˼Ԥޤ"), null);
  //̤֤  
  return new DB_RESULT_INFO(false, null, true);    
}

/*
 * ؿ: DoCheckDBErrorUpdateSome
 * : ꡼ˤpg_exec֤ͤΥ顼åԤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return integer  Կ
*/
function DoCheckDBErrorUpdateSome($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  $cmdtuples = pg_cmdtuples ($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $cmdtuples);    
}

/*
 * ؿ: DoCheckDBErrorDeleteOne
 * : ꡼ˤpg_exec֤ͤΥ顼åȺԿ0ʾǤ뤳Ȥå
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DoCheckDBErrorDeleteOne($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  $cmdtuples = pg_cmdtuples ($result);
  //̤0ʤ饨顼֤  
  if($cmdtuples == 0)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,"DB-703","֥Ȥκ˼Ԥޤ"), null);
  //̤֤
  return new DB_RESULT_INFO(false, null, true);    
}

/*
 * ؿ: DoCheckDBErrorDeleteSome
 * : ꡼ˤpg_exec֤ͤΥ顼åԤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $result  pg_execη̥꥽
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return integer  Կ
*/
function DoCheckDBErrorDeleteSome($con, $result,$file,$line){
  //pg_execηͤå顼ʤ饨顼åФ֤  
  if($result == false)
    return new DB_RESULT_INFO
      (true, new DB_ERROR_INFO($file,$line,GetErrorCode(pg_errormessage($con)),pg_errormessage($con)), null);
  $cmdtuples = pg_cmdtuples ($result);  
  //̤֤
  return new DB_RESULT_INFO(false, null, $cmdtuples);    
}
?>
