/**
 * v6pctool_constraints.sql
 * $Id: v6pctool_constraints.sql,v 1.9 2004/02/23 01:36:37 yoshi_s Exp $
 */


-------------------------------------------------------------------------------
-- mdb
-------------------------------------------------------------------------------

--
-- mdb_meminfo
--

ALTER TABLE ONLY mdb_meminfo
    ADD CONSTRAINT mdb_meminfo_pkey PRIMARY KEY (member_number);
ALTER TABLE ONLY mdb_meminfo
    ADD CONSTRAINT mdb_meminfo_uniq UNIQUE (member_short_name);
ALTER TABLE ONLY mdb_meminfo
    ADD CONSTRAINT mdb_meminfo_check CHECK (status = 'normal' OR status = 'stop' OR status = 'deleting' OR status = 'delete' OR status = 'force_delete');

--
-- cidr_block
--

ALTER TABLE ONLY cidr_block
    ADD CONSTRAINT cidr_block_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY cidr_block
    ADD CONSTRAINT cidr_block_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY cidr_block
    ADD CONSTRAINT cidr_block_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY cidr_block
    ADD CONSTRAINT cidr_block_fkey FOREIGN KEY (member_number) REFERENCES mdb_meminfo(member_number);
ALTER TABLE ONLY cidr_block
    ADD CONSTRAINT cidr_block_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- mdb_ipnetinfo
--

ALTER TABLE ONLY mdb_ipnetinfo
    ADD CONSTRAINT mdb_ipnetinfo_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY mdb_ipnetinfo
    ADD CONSTRAINT mdb_ipnetinfo_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY mdb_ipnetinfo
    ADD CONSTRAINT mdb_ipnetinfo_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY mdb_ipnetinfo
    ADD CONSTRAINT mdb_ipnetinfo_fkey FOREIGN KEY (cidr_block) REFERENCES cidr_block(ip_network_number);
ALTER TABLE ONLY mdb_ipnetinfo
    ADD CONSTRAINT mdb_ipnetinfo_check CHECK (NETWORK(ip_network_number) = ip_network_number);
ALTER TABLE ONLY mdb_ipnetinfo
    ADD CONSTRAINT mdb_ipnetinfo_check2 CHECK (NETWORK(cidr_block) = cidr_block);

--
-- mdb_dnsinfo
--

ALTER TABLE ONLY mdb_dnsinfo
    ADD CONSTRAINT mdb_dnsinfo_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY mdb_dnsinfo
    ADD CONSTRAINT mdb_dnsinfo_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY mdb_dnsinfo
    ADD CONSTRAINT mdb_dnsinfo_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY mdb_dnsinfo
    ADD CONSTRAINT mdb_dnsinfo_fkey FOREIGN KEY (member_number) REFERENCES mdb_meminfo(member_number);
ALTER TABLE ONLY mdb_dnsinfo
    ADD CONSTRAINT mdb_dnsinfo_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- cidr_allocated_block
--

ALTER TABLE ONLY cidr_allocated_block
    ADD CONSTRAINT cidr_allocated_block_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY cidr_allocated_block
    ADD CONSTRAINT cidr_allocated_block_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY cidr_allocated_block
    ADD CONSTRAINT cidr_allocated_block_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY cidr_allocated_block
    ADD CONSTRAINT cidr_allocated_block_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- cidr_allocated_block_history
--

ALTER TABLE ONLY cidr_allocated_block_history
    ADD CONSTRAINT cidr_allocated_block_history_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- cidr_block_update_history
--

ALTER TABLE ONLY cidr_block_update_history
    ADD CONSTRAINT cidr_block_update_history_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- cidr_unallocate_block
--

ALTER TABLE ONLY cidr_unallocate_block
    ADD CONSTRAINT cidr_unallocate_block_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY cidr_unallocate_block
    ADD CONSTRAINT cidr_unallocate_block_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY cidr_unallocate_block
    ADD CONSTRAINT cidr_unallocate_block_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY cidr_unallocate_block
    ADD CONSTRAINT cidr_unallocate_block_fkey FOREIGN KEY (member_number) REFERENCES mdb_meminfo(member_number);
ALTER TABLE ONLY cidr_unallocate_block
    ADD CONSTRAINT cidr_unallocate_block_check CHECK (status = 'unallocated' OR status = 'returned');
ALTER TABLE ONLY cidr_unallocate_block
    ADD CONSTRAINT cidr_unallocate_block_check2 CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- cidr_unallocate_block_history
--

ALTER TABLE ONLY cidr_unallocate_block_history
    ADD CONSTRAINT cidr_unallocate_block_history_check CHECK (status = 'unallocated' OR status = 'returned');
ALTER TABLE ONLY cidr_unallocate_block_history
    ADD CONSTRAINT cidr_unallocate_block_history_check2 CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- mdb_ipnet_technical_resp
--

ALTER TABLE ONLY mdb_ipnet_technical_resp
    ADD CONSTRAINT mdb_ipnet_technical_resp_pkey PRIMARY KEY (ip_network_number, technical_responsibility);
ALTER TABLE ONLY mdb_ipnet_technical_resp
    ADD CONSTRAINT mdb_ipnet_technical_resp_fkey FOREIGN KEY (ip_network_number) REFERENCES mdb_ipnetinfo(ip_network_number);
ALTER TABLE ONLY mdb_ipnet_technical_resp
    ADD CONSTRAINT mdb_ipnet_technical_resp_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- mdb_ipnet_mail_address
--

ALTER TABLE ONLY mdb_ipnet_mail_address
    ADD CONSTRAINT mdb_ipnet_mail_address_pkey PRIMARY KEY (ip_network_number, mail_address);
ALTER TABLE ONLY mdb_ipnet_mail_address
    ADD CONSTRAINT mdb_ipnet_mail_address_fkey FOREIGN KEY (ip_network_number) REFERENCES mdb_ipnetinfo(ip_network_number);
ALTER TABLE ONLY mdb_ipnet_mail_address
    ADD CONSTRAINT mdb_ipnet_mail_address_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- mdb_ipnet_update_history
--

ALTER TABLE ONLY mdb_ipnet_update_history
    ADD CONSTRAINT mdb_ipnet_update_history_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- mdb_mem_notice_address
--

ALTER TABLE ONLY mdb_mem_notice_address
    ADD CONSTRAINT mdb_mem_notice_address_pkey PRIMARY KEY (member_number, notice_address);
ALTER TABLE ONLY mdb_mem_notice_address
    ADD CONSTRAINT mdb_mem_notice_address_fkey FOREIGN KEY (member_number) REFERENCES mdb_meminfo(member_number);

--
-- mdb_dns_update_history
--

ALTER TABLE ONLY mdb_dns_update_history
    ADD CONSTRAINT mdb_dns_update_history_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- mdb_dns_name_server
--

ALTER TABLE ONLY mdb_dns_name_server
    ADD CONSTRAINT mdb_dns_name_server_pkey PRIMARY KEY (ip_network_number, name_server);
ALTER TABLE ONLY mdb_dns_name_server
    ADD CONSTRAINT mdb_dns_name_server_fkey FOREIGN KEY (ip_network_number) REFERENCES mdb_dnsinfo(ip_network_number);
ALTER TABLE ONLY mdb_dns_name_server
    ADD CONSTRAINT mdb_dns_name_server_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- seq_number_management
--

ALTER TABLE ONLY seq_number_management
    ADD CONSTRAINT seq_number_management_pkey PRIMARY KEY (key);

--
-- sdb_member_info
--

ALTER TABLE ONLY sdb_member_info
    ADD CONSTRAINT sdb_member_info_pkey PRIMARY KEY (member_number);
ALTER TABLE ONLY sdb_member_info
    ADD CONSTRAINT sdb_member_info_fkey FOREIGN KEY (member_number) REFERENCES mdb_meminfo(member_number);

--
-- sdb_ip_member
--

ALTER TABLE ONLY sdb_ip_member
    ADD CONSTRAINT sdb_ip_member_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY sdb_ip_member
    ADD CONSTRAINT sdb_ip_member_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY sdb_ip_member
    ADD CONSTRAINT sdb_ip_member_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY sdb_ip_member
    ADD CONSTRAINT sdb_ip_member_check CHECK (status = 'allow' OR status = 'deny');

--
-- sdb_ipv6_member
--

ALTER TABLE ONLY sdb_ipv6_member
    ADD CONSTRAINT sdb_ipv6_member_pkey PRIMARY KEY (ip_network_number);
ALTER TABLE ONLY sdb_ipv6_member
    ADD CONSTRAINT sdb_ipv6_member_uniq UNIQUE (start_sequence_number);
ALTER TABLE ONLY sdb_ipv6_member
    ADD CONSTRAINT sdb_ipv6_member_uniq2 UNIQUE (end_sequence_number);
ALTER TABLE ONLY sdb_ipv6_member
    ADD CONSTRAINT sdb_ipv6_member_check CHECK (status = 'allow' OR status = 'deny');
ALTER TABLE ONLY sdb_ipv6_member
    ADD CONSTRAINT sdb_ipv6_member_check2 CHECK (NETWORK(ip_network_number) = ip_network_number);




-------------------------------------------------------------------------------
-- sdb
-------------------------------------------------------------------------------

--
-- sdb_apply_info
--

ALTER TABLE ONLY sdb_apply_info
    ADD CONSTRAINT sdb_apply_info_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_apply_info
    ADD CONSTRAINT sdb_apply_info_check CHECK (status = 'received' OR status = 'considering' OR status = 'fixed' OR status = 'rejected' OR status = 'canceled');
ALTER TABLE ONLY sdb_apply_info
    ADD CONSTRAINT sdb_apply_info_check2 CHECK (charge_flag = 0 OR charge_flag = 1);

--
-- sdb_form_opr0102
--

ALTER TABLE ONLY sdb_form_opr0102
    ADD CONSTRAINT sdb_form_opr0102_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_opr0102
    ADD CONSTRAINT sdb_form_opr0102_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_ops0101
--

ALTER TABLE ONLY sdb_form_ops0101
    ADD CONSTRAINT sdb_form_ops0101_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0101
    ADD CONSTRAINT sdb_form_ops0101_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_ops0201
--

ALTER TABLE ONLY sdb_form_ops0201
    ADD CONSTRAINT sdb_form_ops0201_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0201
    ADD CONSTRAINT sdb_form_ops0201_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_ops0202
--

ALTER TABLE ONLY sdb_form_ops0202
    ADD CONSTRAINT sdb_form_ops0202_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0202
    ADD CONSTRAINT sdb_form_ops0202_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);
ALTER TABLE ONLY sdb_form_ops0202
    ADD CONSTRAINT sdb_form_ops0202_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- sdb_form_ops0203
--

ALTER TABLE ONLY sdb_form_ops0203
    ADD CONSTRAINT sdb_form_ops0203_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0203
    ADD CONSTRAINT sdb_form_ops0203_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);
ALTER TABLE ONLY sdb_form_ops0203
    ADD CONSTRAINT sdb_form_ops0203_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- sdb_form_ops0204
--

ALTER TABLE ONLY sdb_form_ops0204
    ADD CONSTRAINT sdb_form_ops0204_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0204
    ADD CONSTRAINT sdb_form_ops0204_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);
ALTER TABLE ONLY sdb_form_ops0204
    ADD CONSTRAINT sdb_form_ops0204_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- sdb_form_ops0206
--

ALTER TABLE ONLY sdb_form_ops0206
    ADD CONSTRAINT sdb_form_ops0206_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0206
    ADD CONSTRAINT sdb_form_ops0206_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_ops0207
--

ALTER TABLE ONLY sdb_form_ops0207
    ADD CONSTRAINT sdb_form_ops0207_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0207
    ADD CONSTRAINT sdb_form_ops0207_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_ops0208
--

ALTER TABLE ONLY sdb_form_ops0208
    ADD CONSTRAINT sdb_form_ops0208_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0208
    ADD CONSTRAINT sdb_form_ops0208_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_ops0212
--

ALTER TABLE ONLY sdb_form_ops0212
    ADD CONSTRAINT sdb_form_ops0212_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY sdb_form_ops0212
    ADD CONSTRAINT sdb_form_ops0212_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_clerk_info
--

ALTER TABLE ONLY sdb_clerk_info
    ADD CONSTRAINT sdb_clerk_info_pkey PRIMARY KEY (clerk_id);
ALTER TABLE ONLY sdb_clerk_info
    ADD CONSTRAINT sdb_clerk_info_check CHECK (auth_level = 0 OR auth_level = 1);

--
-- dpn_content
--

ALTER TABLE ONLY dpn_content
    ADD CONSTRAINT dpn_content_pkey PRIMARY KEY (id, accept_id);
ALTER TABLE ONLY dpn_content
    ADD CONSTRAINT dpn_content_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_technical_resp
--

ALTER TABLE ONLY sdb_form_technical_resp
    ADD CONSTRAINT sdb_form_technical_resp_pkey PRIMARY KEY (accept_id, technical_responsibility);
ALTER TABLE ONLY sdb_form_technical_resp
    ADD CONSTRAINT sdb_form_technical_resp_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_allocated_block
--

ALTER TABLE ONLY sdb_allocated_block
    ADD CONSTRAINT sdb_allocated_block_pkey PRIMARY KEY (accept_id, ip_network_number);
ALTER TABLE ONLY sdb_allocated_block
    ADD CONSTRAINT sdb_allocated_block_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);
ALTER TABLE ONLY sdb_allocated_block
    ADD CONSTRAINT sdb_allocated_block_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- sdb_form_ip_network_number
--

ALTER TABLE ONLY sdb_form_ip_network_number
    ADD CONSTRAINT sdb_form_ip_network_number_pkey PRIMARY KEY (accept_id, ip_network_number);
ALTER TABLE ONLY sdb_form_ip_network_number
    ADD CONSTRAINT sdb_form_ip_network_number_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);
ALTER TABLE ONLY sdb_form_ip_network_number
    ADD CONSTRAINT sdb_form_ip_network_number_check CHECK (NETWORK(ip_network_number) = ip_network_number);

--
-- sdb_form_mail_address
--

ALTER TABLE ONLY sdb_form_mail_address
    ADD CONSTRAINT sdb_form_mail_address_pkey PRIMARY KEY (accept_id, mail_address);
ALTER TABLE ONLY sdb_form_mail_address
    ADD CONSTRAINT sdb_form_mail_address_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_name_server
--

ALTER TABLE ONLY sdb_form_name_server
    ADD CONSTRAINT sdb_form_name_server_pkey PRIMARY KEY (accept_id, name_server);
ALTER TABLE ONLY sdb_form_name_server
    ADD CONSTRAINT sdb_form_name_server_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_notice_address
--

ALTER TABLE ONLY sdb_form_notice_address
    ADD CONSTRAINT sdb_form_notice_address_pkey PRIMARY KEY (accept_id, notice_address);
ALTER TABLE ONLY sdb_form_notice_address
    ADD CONSTRAINT sdb_form_notice_address_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- sdb_form_extra_info
--

ALTER TABLE ONLY sdb_form_extra_info
    ADD CONSTRAINT sdb_form_extra_info_pkey PRIMARY KEY (accept_id, extra_info);
ALTER TABLE ONLY sdb_form_extra_info
    ADD CONSTRAINT sdb_form_extra_info_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);

--
-- seq_rcv
--

ALTER TABLE ONLY seq_rcv
    ADD CONSTRAINT seq_rcv_pkey PRIMARY KEY (accept_id);
ALTER TABLE ONLY seq_rcv
    ADD CONSTRAINT seq_rcv_fkey FOREIGN KEY (accept_id) REFERENCES sdb_apply_info(accept_id);


-------------------------------------------------------------------------------
-- rdb
-------------------------------------------------------------------------------

--
-- rdb_ipnetinfo
--

ALTER TABLE ONLY rdb_ipnetinfo
    ADD CONSTRAINT rdb_ipnetinfo_pkey PRIMARY KEY (report_id);
ALTER TABLE ONLY rdb_ipnetinfo
    ADD CONSTRAINT rdb_ipnetinfo_uniq UNIQUE (accept_id, inet6num);

--
-- rdb_admin_c
--

ALTER TABLE ONLY rdb_admin_c
    ADD CONSTRAINT rdb_admin_c_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);


--
-- rdb_tech_c
--

ALTER TABLE ONLY rdb_tech_c
    ADD CONSTRAINT rdb_tech_c_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_rev_srv
--

ALTER TABLE ONLY rdb_rev_srv
    ADD CONSTRAINT rdb_rev_srv_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_remarks
--

ALTER TABLE ONLY rdb_remarks
    ADD CONSTRAINT rdb_remarks_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_notify
--

ALTER TABLE ONLY rdb_notify
    ADD CONSTRAINT rdb_notify_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_mnt_by
--

ALTER TABLE ONLY rdb_mnt_by
    ADD CONSTRAINT rdb_mnt_by_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_mnt_lower
--

ALTER TABLE ONLY rdb_mnt_lower
    ADD CONSTRAINT rdb_mnt_lower_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_mnt_irt
--

ALTER TABLE ONLY rdb_mnt_irt
    ADD CONSTRAINT rdb_mnt_irt_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

--
-- rdb_changed
--

ALTER TABLE ONLY rdb_changed
    ADD CONSTRAINT rdb_changed_fkey FOREIGN KEY (report_id) REFERENCES rdb_ipnetinfo(report_id);

