#!/bin/sh
#
# $Id: gen_reload.sh,v 1.2 2004/03/10 04:01:11 wtetsuya Exp $
#

#
# [desc]
#   ʲνǵհDNSιnamed reloadԤ
#       1. zone ե rsync
#       2. conf ե rsync
#       3. named reload
#   1,2 ｪλʤä硢ʹߤνϼ¹Ԥʤ
#
# [configure]
#   SH_ROOT         ưǥ쥯ȥ
#   CMD_RSYNC       rsync ѥ
#   CMD_RNDC        rndc ѥ
#   RNDC_CONF       rndc.conf եѥ
#   SRC_ZONE_DIR    zone եžǥ쥯ȥ( / ɬ)
#   SRC_CONF_DIR    conf եžǥ쥯ȥ( / ɬ)
#   DEST_ZONE_DIR   zone եžǥ쥯ȥ( / )
#   DEST_CONF_DIR   conf եžǥ쥯ȥ( / )
#
# [result]
#   0   zone & conf rsyncnamed reload 
#   1   zone rsync 
#   2   conf rsync 
#   3   named reload 
#

##
# configure
##
SH_ROOT=`dirname $0`

CMD_RSYNC='/usr/local/bin/rsync'
CMD_RNDC='/usr/local/sbin/rndc'
RNDC_CONF='/usr/local/etc/namedb/rndc.conf'

SRC_ZONE_DIR='$SH_ROOT/DB/'
SRC_CONF_DIR='$SH_ROOT/conf/'
DEST_ZONE_DIR='/usr/local/etc/namedb/DB'
DEST_CONF_DIR='/usr/local/etc/namedb/conf'

error=0

##
# main routine
##
# zone rsync
$CMD_RSYNC -rlptDzv --delete --exclude '*~' $SRC_ZONE_DIR $DEST_ZONE_DIR

if [ $? -eq 0 ]; then
  echo "[inc0103] zone rsync completed."
  # conf rsync
  $CMD_RSYNC -rlptDzv --delete --exclude '*~' $SRC_CONF_DIR $DEST_CONF_DIR

  if [ $? -eq 0 ]; then
    echo "[inc0103] conf rsync completed."
    # named reload
    $CMD_RNDC -c $RNDC_CONF reload

    if [ $? -eq 0 ]; then
      echo "[inc0103] named reload completed."
    else
      error=3
      echo "[inc0103] failed named reload." 1>&2
    fi
  else
    error=2
    echo "[inc0103] failed conf rsync." 1>&2
  fi
else
  error=1
  echo "[inc0103] failed zone rsync." 1>&2
fi

##
# exit
##
exit $error
